unit DM_Zeos;

{$mode ObjFPC}{$H+}

interface

uses
   LclType, Classes, SysUtils, Forms, db, ZConnection, ZDataset;

type

   { Tdm }

   Tdm = class(TDataModule)
      con: TZConnection;
      qry: TZReadOnlyQuery;

   private

   public
	    function OpenQry(xSql: AnsiString): boolean;

   end;


function  QryCount: integer; inline;
function QryFld(const fld: string): TField; inline;

var
   MyData: Tdm;

implementation

function QryCount: integer;
begin
  result := MyData.qry.RecordCount;
end;

function QryFld(const fld: string): TField; inline;
begin
   result := MyData.qry.FieldByName(fld);
end;

{$R *.lfm}

{ Tdm }

function Tdm.OpenQry(xSql: AnsiString): boolean;
begin
  Result := false;
  qry.Close;
  qry.Filtered := False;
  qry.SQL.Text := xSql;

  try	//-- Öffnen versuchen --
      qry.Open;
      Result := qry.Active;

  except	//-- Fehler --
     on E: Exception do
        Application.MessageBox(PChar(E.Message), 'OpenQry', MB_OK);
  end;
end;

end.

