unit cErdRefs;

{$mode objfpc}{$H+}

interface

uses
   Classes, SysUtils, Forms, ErRef;

type
  tRefData = record
    nMstNdx:   integer;    // Master-Index
    nDetNdx:   integer;    // Detail-Index

    oErRef:       TErRef;
    bIsVis:       boolean;
  end;

  { tRefs }
  tRefs = class(TObject)
    private
      aRefs:      array of tRefData;
      nCount:     integer;

      procedure Clear;
      function Get(Index: Integer): tRefData;
      procedure Put(Index: Integer; AValue: tRefData);

    public
   	constructor Create;
      destructor Destroy; override;

      procedure Prepare(nCnt: integer; sBox: TScrollBox);
      procedure AddRef(ndx, NdxMst, NdxDet: integer);
      procedure HideAll;

      property Count: integer read nCount;
      property Items[Index: Integer]: tRefData read Get write Put; default;
  end;

implementation

{ tRefs }

constructor tRefs.Create;
begin
   inherited Create;
end;

destructor tRefs.Destroy;
begin
   SetLength(aRefs, 0);

   inherited Destroy;
end;

procedure tRefs.Prepare(nCnt: integer; sBox: TScrollBox);
   var   i: integer;
begin
   if nCount > 0 then
      Clear;

   nCount := nCnt;
   SetLength(aRefs, nCnt);

   for i := 0 to nCount -1 do begin
      aRefs[i].oErRef :=  tErRef.Create(sBox);
      aRefs[i].oErRef.Parent := sBox;
      aRefs[i].oErRef.Visible := True;
   end;
end;

procedure tRefs.Clear;
   var   i: integer;
begin
   for i := 0 to nCount -1 do
      aRefs[i].oErRef.Free;
end;

function tRefs.Get(Index: Integer): tRefData;
begin
   Result := aRefs[index];
end;

procedure tRefs.Put(Index: Integer; AValue: tRefData);
begin
   aRefs[index] := aValue;
end;

procedure tRefs.AddRef(ndx, NdxMst, NdxDet: integer);
begin
   aRefs[ndx].nMstNdx := NdxMst;
   aRefs[ndx].nDetNdx := NdxDet;
end;

procedure tRefs.HideAll;
   var   i: integer;
begin
   for i := 0 to nCount -1 do
      aRefs[i].oErRef.Visible := False;
end;


end.

